/*
 * Copyright (C) 2017-2018 Yantra Cloud Ltd. <https://yantra.cloud>
 */

package cloud.yantra.patterns.actors.entities

import akka.actor.{Actor, ActorLogging, ActorRef, Props}
import akka.cluster.pubsub.DistributedPubSub
import akka.cluster.pubsub.DistributedPubSubMediator.{Publish, Subscribe, SubscribeAck}
import cloud.yantra.patterns.actors.entities.EntityManagerActor.Commands.AuthorizedCommand
import cloud.yantra.patterns.actors.entities.EntityManagerActor.Events.ObservedEvent
import cloud.yantra.patterns.cqrs.{Command, CreateCommand, QueryCommand, UpdateCommand}
import cloud.yantra.patterns.es._

abstract class EntityManagerActor[Ent <: Entity](className: Class[Ent])
  extends Actor
    with ActorLogging {

  /**
    * Capture the [[DistributedPubSub]] mediator for publishing events generated by [[EntityPersistentActor]].
    * Interested parties will consume this events and react to them.
    *
    * @return
    */
  def mediator(): ActorRef = DistributedPubSub(context.system).mediator

  /**
    * Topics to which the [[EntityPersistentActor]] will publish the [[Event]].
    * This a list of topics to which the [[Event]] will be published, in addition to topic tagged to
    * a [[Publishable]] event.
    *
    * @return
    */
  def publishToDomainEventTopics: Seq[String]

  /**
    * Topic to which the [[EntityManagerActor]] will listen for the [[cloud.yantra.patterns.cqrs.Command]].
    * The [[cloud.yantra.patterns.cqrs.Command]] is expected to be a validated i.e. validated by
    * Command Gateway [[cloud.yantra.patterns.actors.commands.CommandProcessorManagerActor]].
    * These topics need to be private topics within the domain, and MUST not be available to systems/actors
    * outside this domain.
    *
    * @return
    */
  def subscribeToValidatedCommandTopics: Seq[String]

  /**
    * Should return [[Props]] that belongs to an [[EntityPersistentActor]]. The [[Props]] should be able to handle
    * entities belonging to entity type [[Ent]].
    *
    * @param entityId
    * @return
    */
  def entityProps(entityId: EntityId): Props

  override def preStart(): Unit = {
    log.debug("Subscription by [{}] to validated command topics [{}]",
      self.path,
      subscribeToValidatedCommandTopics.mkString(","))
    // Subscribe for listening
    subscribeToValidatedCommandTopics.foreach(commandTopic => mediator ! Subscribe(commandTopic, self))
    super.preStart()
  }

  override def receive: Receive = handleCommands

  /**
    * Handles all Create and Update commands for an [[Entity]]
    *
    * @return
    */
  private def handleCommands: Receive = {
    case msg@AuthorizedCommand(cmd: CreateCommand[Ent], _) =>
      log.debug("Received command for [{}] with data : {}", cmd.getClass.getCanonicalName, cmd.toString)
      // Create a child entity
      val entityId: EntityId = EntityUuid()
      val entityActor = fetchPersistentEntity(entityId)
      log.debug("Entity created by manager [{}] at [{}].", this.self.path, entityActor.path)
      // Send the Create command to child
      entityActor ! msg

    case msg@AuthorizedCommand(cmd: UpdateCommand[Ent], _) =>
      val entityActor = fetchPersistentEntity(cmd.entityId)
      log.debug("Entity manager at [{}] attempting to send update command to [{}].",
        this.self.path,
        entityActor.path)
      entityActor ! msg

    case msg@AuthorizedCommand(cmd: QueryCommand, _) =>
      val entityActor = fetchPersistentEntity(cmd.entityId)
      log.debug("Entity manager at [{}] attempting to send query command to [{}].",
        this.self.path,
        entityActor.path)
      entityActor ! msg

    case ObservedEvent(event, commandHandler) =>
      log.debug("Received event from {} with data : {}", sender.path, event.toString)
      if (event.isInstanceOf[Publishable]) {
        val topics = event.asInstanceOf[Publishable].topics()
        log.debug("Publishing event [{}] to topic [{}].", event, topics)
        // Publish to Event nominated topics
        topics.foreach(evTopic => mediator ! Publish(evTopic, event))
        // Publish to Entity manager nominated topics
        publishToDomainEventTopics.foreach(emTopic => mediator ! Publish(emTopic, event))
      }
      commandHandler match {
        case Some(ref) => ref ! event
        case None => // Do Nothing
      }

    case SubscribeAck(Subscribe(topic, group, actor)) =>
      log.debug("Enitity manager at [{}] subscribed to topic [{}] form group [{}] for actor [{}]",
        self.path, topic, group, actor.path)

    case unknown =>
      log.warning("Received something that I do not understand. Its of type [{}] and data : {}",
        unknown.getClass.getCanonicalName,
        unknown)
  }

  private def fetchPersistentEntity(entityId: EntityId): ActorRef = context.child(entityPath(entityId)) match {
    case Some(entityActor) =>
      entityActor
    case None =>
      context.actorOf(entityProps(entityId), entityPath(entityId))
  }

  private def entityPath(entityId: EntityId): String = EntityPersistentActor.entityPersistenceId(className, entityId)

}


object EntityManagerActor {

  object Commands {

    case class AuthorizedCommand[Cmd <: Command](command: Cmd, commandHandler: Option[ActorRef])

  }

  object Events {

    case class ObservedEvent(event: Event, commandHandler: Option[ActorRef])

  }

}
